<template>
  <div class="content">
    <students-table @student-selected="studentSelected"></students-table>
    <div class="newStudent">
      <h4 v-if="isAdding">Add New Student</h4>
      <h4 v-else>Edit Existing Student</h4>
      <hr>
      <div class="newStudentForm">
          <label class="formLabel">First Name</label>
          <input type="text" placeholder="First Name" v-model="newStudent.first_name">
          <label class="formLabel">Last Name</label>
          <input type="text" placeholder="Last Name" v-model="newStudent.last_name"> 
          <label class="formLabel">Email</label>
          <input type="text" placeholder="Email" v-model="newStudent.email">
          <label class="formLabel">JMBG</label>
          <input type="text" placeholder="JMBG" v-model="newStudent.jmbg">
          <label v-show="isEditing" class="formLabel">Password</label>
          <input v-show="isEditing" type="text" placeholder="Password" v-model="newStudent.password" class="password">
          <input type="submit" class="newStudentSubmit" :value="isAdding ? 'ADD' : 'UPDATE'" @click="saveStudent()">
          <input v-show="isEditing" type="submit" class="newStudentSubmit" value="ADD NEW" @click="openAdd()">

          <div v-show="isSuccessfullyAdded" class="notify">
              <p>User has been succesfully added</p>
          </div>
      </div>
  </div>
</div>
  <!--<div->
    <students-commands :selectedStudent="selectedStudent" @edit-pressed="openEdit" @add-pressed="openAdd"></students-commands>
    <div v-show="isAddOrEditOn" class="add-new-form">
      <button @click="saveStudent()">Save</button>
      <button @click="cancel()">Cancel</button>
      <input  placeholder="JMBG" 
                          :class="{required: (newStudent.jmbg === '' && check)}"
                          v-model="newStudent.jmbg" required>
      <input  placeholder="Name" 
                          :class="{required: (newStudent.first_name === '' && check)}"
                          v-model="newStudent.first_name" required>
      <input  placeholder="Last Name" 
                          :class="{required: (newStudent.last_name === '' && check)}"
                          v-model="newStudent.last_name" required>
      <input type="email" placeholder="Email" 
                          :class="{required: (newStudent.email === '' && check)}"
                          v-model="newStudent.email" required>
      <input  placeholder="Password" 
                          :class="{required: (newStudent.password === '' && check)}"
                          v-model="newStudent.password" required>
    </div>
    <students-table :selectedStudent="selectedStudent" @student-selected="studentSelected"></students-table>
  </div>-->
</template>

<script>
import store from '../../store/store.js'
import axios from 'axios'
import StudentsCommands from './StudentsCommands.vue'
import StudentsTable from './StudentsTable.vue'
import {mapGetters} from 'vuex'

export default {
  data () {
    return {
      selectedStudent: null,
      newStudent: {
        id: '',
        jmbg: '',
        first_name: '',
        last_name: '',
        email: '',
        password: '', 
      },
      check: false,
      isAdding: true,
      isEditing: false,
      isSuccessfullyAdded: false
    }
  },
  methods: {
    studentSelected(student) {
      this.selectedStudent = student;
      this.openEdit();
    },

    openEdit () {
      this.isEditing = true;
      this.isAdding = false;
      this.newStudent = JSON.parse(JSON.stringify(this.selectedStudent));
      this.isSuccessfullyAdded = false;
    },
    
    openAdd () {
      this.isAdding = true;
      this.isEditing = false;
      this.clearFields();
      this.isSuccessfullyAdded = false;
    },
    cancel () {
      this.isAdding = false;
      this.isEditing = false; 
      this.clearFields();
    },
    clearFields () {
      this.newStudent = {
        id: '',
        jmbg: '',
        first_name: '',
        last_name: '',
        email: '',
        password: '', 
      };
    },
    saveStudent () {
      if (this.isAdding)
        this.addStudent();
      if (this.isEditing)
        this.editStudent();
    },
    addStudent () {
      delete this.newStudent.id;
      var vm = this;
      this.newStudent.password = this.newStudent.jmbg;
      axios.post(this.server + '/user', JSON.stringify(this.newStudent))
      .then(function (response) {
        // console.log(response);
        // vm.updateStudents(); 
        this.isSuccessfullyAdded = true;
        vm.$emit('updateStudents');
      }.bind(this))
      .catch((error) => {
        console.log(error);
        // vm.errors = []
        // vm.errors.push(error.response.data.error)
      });
    },
    editStudent () {
      var vm = this;
      axios.put(this.server + '/user/' + this.newStudent.id, JSON.stringify(this.newStudent))
      .then(function (response) {
        // console.log(response);
        // vm.updateStudents(); 
        this.isSuccessfullyAdded = true;
        vm.$emit('updateStudents');
      }.bind(this))
      .catch((error) => {
        console.log(error.code);
        // if(error.response.data.error)
        // vm.errors = []
        // vm.errors.push(error.response.data.error)
      });
    }
  },
  computed: {
    ...mapGetters([
      'server'
    ]),
    isAddOrEditOn () {
      return this.isAdding || this.isEditing;
    }
  },
  components: {
    "students-commands": StudentsCommands,
    "students-table": StudentsTable
  }
}
</script>

<style lang="scss">
div.add-new-form {
  float: left;
  width: 75%;
  height: 10%;
  margin-left: 4%;

}

.formLabel{
  display: block; 
}

.newStudentForm div{
  display: flex;
  flex-direction: row;
}

.newStudentForm input {
  width: 100%;
}
</style>